/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>
#include "List.h"
#include "ConnectionList.h"

ConnectionList::ConnectionList(int i, char *h, char *s, int snt, int rec,
		int dr, int out, int cid) : List(LIST_TYPE_CONNECTIONS)
{
	id		= i;
	sent		= snt;
	received	= rec;
	dropped		= dr;
	outgoing	= out;
	knownCID	= cid;
	memcpy(host, h, CLEN);
	host[CLEN - 1 ]	= 0;
	memcpy(state, s, CLEN);
	state[CLEN - 1 ]= 0;
}

int ConnectionList::getID()
{
	return id;
}

void ConnectionList::getHost(char *buf)
{
	strcpy(buf, host);
}

void ConnectionList::getState(char *buf)
{
	strcpy(buf, state);
}

int ConnectionList::getSent()
{
	return sent;
}

int ConnectionList::getReceived()
{
	return received;
}

int ConnectionList::getDropped()
{
	return dropped;
}

int ConnectionList::isOutgoing()
{
	return outgoing;
}

int ConnectionList::hasKnownCID()
{
	return knownCID;
}


