/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define API_VERSION		"0.1"
#define PROMPT			"Hagelslag > "
#define ERROR			"Error : "
#define BUFLEN			192000

/*
 * list
 */
#define	LIST_RESULTS		0
#define LIST_HOSTS		1
#define LIST_DOWNLOADS		2
#define LIST_UPLOADS		3
#define LIST_CONNECTIONS	4
#define LIST_SHARES		5
#define LIST_OPTIONS		6
#define LIST_STATS		7
#define LIST_QUERIES		8
#define LIST_ERRORS		9

/*
 *Set
 */
#define SET_MAX_TTL		0
#define SET_DEFAULT_TTL		1
#define SET_MAX_CONNECTIONS	2
#define SET_ROUTING_TABLE_SIZE	3
#define SET_MAX_HOPS		4
#define SET_MAX_UPLOADS		5
#define SET_MAX_DOWNLOADS	6
#define SET_MAX_RESULTS		7
#define SET_PORT		8
#define SET_SPEED		9
#define SET_DOWNLOAD_DIR	10
#define SET_AUTO_PUSH		11
#define SET_AUTO_CLEAR_COMPLETE	12
#define SET_AUTO_CONNECTIONS	13
#define SET_MAX_MONITOR_LENGTH	14

/*
 * host
 */
#define HOST_ADD		0
#define HOST_DEL		1
#define HOST_CONNECT		2

/*
 * download
 */
#define DOWNLOAD_HOW_START	0
#define DOWNLOAD_HOW_CONTINUE	1
#define DOWNLOAD_HOW_PUSH	2

/*
 * search
 */
#define SEARCH_FIND		0
#define SEARCH_CLEAR		1

/*
 * share
 */
#define SHARE_ADD		0
#define SHARE_DEL		1
#define SHARE_CLEAR		2

/*
 * save
 */
#define SAVE_OPTIONS		0
#define SAVE_HOSTS		1
#define SAVE_SHARES		2

/*
 * kill
 */

#define KILL_DOWNLOAD		0
#define KILL_UPLOAD		1
#define KILL_CONNECTION		2

class HagelslagInterface
{
	private:
		int		port;
		int		sock;
		char		buf[BUFLEN];
		int		sendStr(char *arg);
		int		readStr();
		ListMaker	lm;
		List		*listAllSomething(int what, int howMany, int step);
				
	public:
		HagelslagInterface();

		/*
		 * starting & stopping
		 */		
		int		startHagelslag(char *path, int newPort);
		
		int		stopHagelslag();
		
		int		disconnectHagelslag();
		
		int		connectHagelslag();
		
		int		connectHagelslag(char *host, int atPort);
		
		/*
		 * Issue a command
		 */
		 
		List		*list(int listType, int offset);
		 
		ErrorList	*set(int param, int val, char *arg);
		 
		ErrorList	*host(int doWhat, int who, char *arg);
		 
		ErrorList	*download(int how, int which);
		 
		ErrorList	*kill(int what, int which);
		 
		ErrorList	*share(int doWhat, char *arg);
		 
		ErrorList	*save(int what);
		 
		ErrorList	*scan();
		 
		ErrorList	*search(int doWhat, int speed, char *arg);

		void		getHagelslagVersion(char *ver);

		void		getApiVersion(char *ver);

		/*
		 * Extra's. These are very resource-demanding methods.
		 */
		
		 List		*listAllHosts();
		
		 List		*listAllConnections();
		
		 List		*listAllResults();
};
