/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>
#include "List.h"
#include "OptionList.h"

OptionList::OptionList(int mttl, int dttl, int rts, int mcon, int mres,
			int mhop, int mpr, int mu, int md, int mh, int p,
			int sp, int ml, int ap, int acc, int ac, char *dd,
			int dp) : List (LIST_TYPE_OPTIONS)
{
	maxTTL			= mttl;
	defaultTTL		= dttl;
	routingTableSize	= rts;
	maxConnections		= mcon;
	maxResults		= mres;
	maxHops			= mhop;
	maxPushRequests		= mpr;
	maxUploads		= mu;
	maxDownloads		= md;
	maxHosts		= mh;
	port			= p;
	speed			= sp;
	monitorLength		= ml;
	autoPush		= ap;
	autoClearComplete 	= acc;
	autoConnections		= ac;
	daemonPort		= dp;
	memcpy(downloadDir, dd, OLEN);
	downloadDir[ OLEN - 1 ]	= 0;
}

int OptionList::getMaxTTL()
{
	return maxTTL;
}

int OptionList::getDefaultTTL()
{
	return defaultTTL;
}

int OptionList::getRoutingTableSize()
{
	return routingTableSize;
}

int OptionList::getMaxConnections()
{
	return maxConnections;
}

int OptionList::getMaxResults()
{
	return maxResults;
}

int OptionList::getMaxHops()
{
	return maxHops;
}

int OptionList::getMaxPushRequests()
{
	return maxPushRequests;
}

int OptionList::getMaxUploads()
{
	return maxUploads;
}

int OptionList::getMaxDownloads()
{
	return maxDownloads;
}

int OptionList::getMaxHosts()
{
	return maxHosts;
}

int OptionList::getPort()
{
	return port;
}

int OptionList::getSpeed()
{
	return speed;
}

int OptionList::getMonitorLength()
{
	return monitorLength;
}

int OptionList::getAutoPush()
{
	return autoPush;
}

int OptionList::getAutoClearComplete()
{
	return autoClearComplete;
}

int OptionList::getAutoConnections()
{
	return autoConnections;
}

int OptionList::getDaemonPort()
{
	return daemonPort;
}

void OptionList::getDownloadDir(char *buf)
{
	strcpy(buf, downloadDir);
}
