/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

import List;

class ConnectionList extends List
{
	private int     id;
	private String	host;
	private String	state;
        private	int	sent;
	private int	received;
	private int     dropped;
	private boolean outgoing;
	private boolean	knownCID;

	public ConnectionList(int newId, String newHost, String newState,
			int newSent, int newRecvd, int newDropped,
			boolean newOutgoing, boolean newKnownCID)
	{
		super(List.LIST_TYPE_CONNECTIONS);
		id		= newId;
		host		= new String(newHost);
		state		= new String(newState);
		sent		= newSent;
		received	= newRecvd;
		dropped		= newDropped;
		outgoing	= newOutgoing;
		knownCID	= newKnownCID;
	}

	public ConnectionList(int newId, String newHost, String newState,
			int newSent, int newRecvd, int newDropped,
			boolean newOutgoing, boolean newKnownCID,
			List newNext)
	{
		super(List.LIST_TYPE_CONNECTIONS, newNext);
		
		id		= newId;
		host		= new String(newHost);
		state		= new String(newState);
		sent		= newSent;
		received	= newRecvd;
		dropped		= newDropped;
		outgoing	= newOutgoing;
		knownCID	= newKnownCID;
	}

	public int getId()
	{
		return id;
	}

	public String getHost()
	{
		return host;
	}

	public String getState()
	{
		return state;
	}

	public int getSent()
	{
		return sent;
	}

	public int getReceived()
	{
		return received;
	}

	public int getDropped()
	{
		return dropped;
	}

	public boolean isOutgoing()
	{
		return outgoing;
	}

	public boolean hasKnownCID()
	{
		return knownCID;
	}
}