/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

import List;
import ConnectionList;
import DownloadList;
import ErrorList;
import HostList;
import OptionList;
import QueryList;
import ResultList;
import ShareList;
import StatList;
import UploadList;
import ListMaker;
import HagelslagInterface;

abstract class HagelslagInterface
{
	public static final String	API_VERSION             = "0.1";
	public static final String	PROMPT                  = "Hagelslag > "
	public static final String	ERROR                   = "Error : "
	public static final int	 	BUFLEN                  = 192000;

	/*
	 * list
	 */
	public static final int	 LIST_RESULTS            = 0;
	public static final int	 LIST_HOSTS              = 1;
	public static final int	 LIST_DOWNLOADS          = 2;
	public static final int	 LIST_UPLOADS            = 3;
	public static final int	 LIST_CONNECTIONS        = 4;
	public static final int	 LIST_SHARES             = 5;
	public static final int	 LIST_OPTIONS            = 6;
	public static final int	 LIST_STATS              = 7;
	public static final int	 LIST_QUERIES            = 8;
	public static final int	 LIST_ERRORS             = 9;

	/*
	 *Set
	 */
	public static final int	 SET_MAX_TTL             = 0;
	public static final int	 SET_DEFAULT_TTL         = 1;
	public static final int	 SET_MAX_CONNECTIONS     = 2;
	public static final int	 SET_ROUTING_TABLE_SIZE  = 3;
	public static final int	 SET_MAX_HOPS            = 4;
	public static final int	 SET_MAX_UPLOADS         = 5;
	public static final int	 SET_MAX_DOWNLOADS       = 6;
	public static final int	 SET_MAX_RESULTS         = 7;
	public static final int	 SET_PORT                = 8;
	public static final int	 SET_SPEED               = 9;
	public static final int	 SET_DOWNLOAD_DIR        = 10;
	public static final int	 SET_AUTO_PUSH           = 11;
	public static final int	 SET_AUTO_CLEAR_COMPLETE = 12;
	public static final int	 SET_AUTO_CONNECTIONS    = 13;
	public static final int	 SET_MAX_MONITOR_LENGTH  = 14;

	/*
	 * host
	 */
	public static final int	 HOST_ADD                = 0;
	public static final int	 HOST_DEL                = 1;
	public static final int	 HOST_CONNECT            = 2;

	/*
	 * download
	 */
	public static final int	 DOWNLOAD_HOW_START      = 0;
	public static final int	 DOWNLOAD_HOW_CONTINUE   = 1;
	public static final int	 DOWNLOAD_HOW_PUSH       = 2;

	/*
	 * share
	 */
	public static final int	 SHARE_ADD               = 0;
	public static final int	 SHARE_DEL               = 1;
	public static final int	 SHARE_CLEAR             = 2;

	/*
	 * save
	 */
	public static final int	 SAVE_OPTIONS            = 0;
	public static final int	 SAVE_HOSTS              = 1;
	public static final int	 SAVE_SHARES             = 2;

	/*
	 * kill
	 */

	public static final int	 KILL_DOWNLOAD           = 0;
	public static final int	 KILL_UPLOAD             = 1;
	public static final int	 KILL_CONNECTION         = 2;

	public HagelslagInterface()
	{
		buf	= null;
		sock	= 0;
		port	= 0;
	}

	public int startHagelslag(String path, int newPort)
	{
/*		int		res;
		struct stat	junk;
		String		executable;
	
		port	= newPort;
	
		if ((!path) || (!path[0]))
		{
	
			res	= -1;
			if (!stat("/usr/bin/hagelslagd", &junk))
			{
				executable	= new String("/usr/bin/hagelslagd -p " + port + " &");
				res	= system(executable);
			}
       	
			if ( (res == -1) || (res == 127) )
			{
				if (!stat("/usr/bin/hagelslagd", &junk))
				{
					executable	= new String("/usr/local/bin/hagelslagd -p " + port + " &");
					res	= system(executable);
				}
			}
       	
			if ( (res == -1) || (res == 127) )
				return 0;
		}
		else
			if (!stat(executable, &junk))
			{
				executable	= new String(path +" -p " + port + " &");
				res	= system(executable);
				if ( (res == -1) || (res == 127) )
					return 0;
			}
*/       	
		return 1;
	}      	

	public int stopHagelslag()
	{
		if (!sendStr("quit\n"))
			return 0;
	
		close (sock);
		return 1;
	}
	
	public int disconnectHagelslag()
	{      	
		if (!sendStr("holdon\n"))
			return 0;
        	
		close (sock);
		return 1;
	}
	
	public int connectHagelslag()
	{
/*		struct sockaddr_in	sa;
		struct hostent		*h;
		String			host;
	
		gethostname(host, 256);
		sa.sin_port		= htons(port);
		sa.sin_family		= PF_INET;
		h			= gethostbyname(host);
		sa.sin_addr.s_addr	= *(unsigned long int *)h->h_addr_list[0];
		if ((sock 		= socket(PF_INET, SOCK_STREAM, 0)) == -1)
		{
			system.out.fprintf(stderr, "HagelslagInterface::connectHagelslag() : socket() failed!!\n");
			return 0;
		}
       	
		sleep (3);
		if (connect(sock, (struct sockaddr *)&sa, sizeof(sa)))
		{
			system.out.fprintf(stderr, "HagelslagInterface::connectHagelslag() : Connect failed!!\n");
			return 0;
		}
		readStr();
		if (!strstr(buf, PROMPT))
		{
			system.out.fprintf(stderr, "HagelslagInterface::connectHagelslag() : No prompt!!\n");
			close(sock);
			return 0;
		}
*/		return 1;
	}

	public List list(int listType, int offset)
	{
		String	out;
		List	l;
       	
		switch (listType)
		{
			case	LIST_RESULTS	:
						out	= new String("list results " +
										offset + "\n");
						break;
			case	LIST_HOSTS	:
						out	= new String("list hosts " +
										offset + "\n");
						break;
			case	LIST_DOWNLOADS	: out	= new String("list downloads\n");
						break;
			case	LIST_UPLOADS	: out	= new String("list uploads\n");
						break;
			case	LIST_CONNECTIONS:
						out	= new String("list connections " +
										offset, "\n");
						break;
			case	LIST_SHARES	: out	= new String("list shares\n");
						break;
			case	LIST_OPTIONS	: out	= new String("list options\n");
						break;
			case	LIST_STATS	: out	= new String("list stats\n");
						break;
			case	LIST_QUERIES	: out	= new String("list queries\n");
						break;
			default		:
					return new ErrorList("Unknown ListType");
		}
       	
		sendStr(out);
		readStr();

		if (!strncmp(buf, PROMPT, strlen(PROMPT)))
			l	= 0;
		else
		{
			l	= lm.makeList(listType, buf);
			/*
			 * Read the Prompt
			 */
			readStr();
			if (strncmp(buf, PROMPT, strlen(PROMPT)))
				system.out.writeln("HagelslagInterface::list() : No PROMPT ?\n");
		}	
		
		return l;
	}      	
       	
	public ErrorList set(int param, int val, String arg)
	{
		String	outbuf;
	
		switch(param)
		{
			case	SET_MAX_TTL		:	
					outbuf	= new String ("set MAX_TTL " + val + "\n");
					break;
			case	SET_DEFAULT_TTL		:	
					outbuf	= new String ("set DEFAULT_TTL " + val + "\n");
					break;
			case	SET_MAX_CONNECTIONS	:	
					outbuf	= new String ("set MAX_CONNECTIONS " + val + "\n");
					break;
			case	SET_ROUTING_TABLE_SIZE	:	
					outbuf	= new String ("set ROUTING_TABLE_SIZE " + val + "\n");
					break;
			case	SET_MAX_HOPS		:	
					outbuf	= new String ("set MAX_HOPS " + val + "\n");
					break;
			case	SET_MAX_UPLOADS		:	
					outbuf	= new String ("set MAX_UPLOADS " + val + "\n");
					break;
			case	SET_MAX_DOWNLOADS	:	
					outbuf	= new String ("set MAX_DOWNLOADS " + val + "\n");
					break;
			case	SET_MAX_RESULTS		:	
					outbuf	= new String ("set MAX_RESULTS " + val + "\n");
					break;
			case	SET_PORT		:	
					outbuf	= new String ("set PORT " + val + "\n");
					break;
			case	SET_SPEED		:	
					outbuf	= new String ("set SPEED " + val + "\n");
					break;
			case	SET_DOWNLOAD_DIR	:	
					outbuf	= new String ("set DOWNLOAD_DIR " + arg + "\n");
					break;
			case	SET_AUTO_PUSH		:	
					outbuf	= new String ("set AUTO_PUSH " + val + "\n");
					break;
			case	SET_AUTO_CLEAR_COMPLETE	:	
					outbuf	= new String ("set AUTO_CLEAR_COMPLETE " + val + "\n");
					break;
			case	SET_AUTO_CONNECTIONS	:	
					outbuf	= new String ("set AUTO_CONNECTIONS " + val + "\n");
					break;
			case	SET_MAX_MONITOR_LENGTH	:	
					outbuf	= new String ("set MAX_MONITOR_LENGTH " + val + "\n");
					break;
		}
       	
		sendStr(outbuf);
		readStr();
		return lm.makeErrorList(buf);
	}

	public ErrorList host(int doWhat, int who, String arg)
	{
	        String    out;
	
		switch (doWhat)
		{
			case	HOST_ADD	:
						out	= new String("host add " + arg + "\n");
						break;
			case	HOST_DEL	:
						out	= new String("host del " + who + "\n");
						break;
			case	HOST_CONNECT	:
						out	= new String("host connect " + who + "\n");
						break;
			default		: return 0;
		}
       	
		sendStr(out);
		readStr();
		return lm.makeErrorList(buf);
	}      	

	public ErrorList download(int how, int which)
	{
		String	out;
       	
		switch(how)
		{
			case DOWNLOAD_HOW_START		:
				out	= new String("download start " + which + "\n");
						break;
			case DOWNLOAD_HOW_CONTINUE	:
				out	= new String("download continue " + which + "\n");
						break;
			case DOWNLOAD_HOW_PUSH		:
				out	= new String("download push" + which + "\n");
						break;
			default	:
					return 0;
		}
		sendStr(out);
		readStr();
		return lm.makeErrorList(buf);
	}      	

	public ErrorList share(int doWhat, String arg)
	{
		String	out;
	
		switch(doWhat)
		{
			case	SHARE_ADD	:
					out	= new String("share add " + arg + "\n");
						break;
			case	SHARE_DEL	:
					out	= new String("share del " + arg + "\n");
						break;
			case	SHARE_CLEAR	:
					out	= new String("share clear\n");
						break;
			default	: return 0;
		}
       	
		sendStr(out);
		readStr();
		return lm.makeErrorList(buf);
	}

	public ErrorList save(int what)
	{
		switch (what)
		{
			case SAVE_OPTIONS	: sendStr("save options\n");
							break;
			case SAVE_HOSTS		: sendStr("save hosts\n");
							break;
			case SAVE_SHARES	: sendStr("save shares\n");
							break;
		}
	
		readStr();
		return lm.makeErrorList(buf);	
	}      	

	public ErrorList kill(int what, int which)
	{
		String	str;
	
		switch (what)
		{
			case KILL_CONNECTION	: str	= new String("kill connection " +
								which + "\n");
							break;
			case KILL_UPLOAD	: str	= new String("kill upload " +
								which + "\n");
							break;
			case KILL_DOWNLOAD	: str	= new String("kill download " +
								which + "\n");
							break;
		}
       	
		sendStr(str);
		readStr();
		return lm.makeErrorList(buf);
	}

	public ErrorList scan()
	{
		sendStr("scan\n");
		readStr();
		return lm.makeErrorList(buf);
	}      	

	public ErrorList search(int speed, String arg)
	{
		String	out;
       	
		out	= new String("search " + speed + " " + arg + "\n");
		sendStr(out);
		readStr();
		return lm.makeErrorList(buf);
	}      	

	private List listAllSomething(int what, int howMany, int step)
	{
	        int     i;
	        List    l, prv;

	        l       = null;
	        for(i = 0; i < howMany; i += step)
	        {
	                prv     = l;
	                l       = list(what, i);
	                if (l)
	                {
	                        List    *tmp;

       		                for (tmp = l; tmp->getNext(); tmp= tmp->getNext())
                                	;
	                        tmp->setNext(prv);
	                }
	                else
	                        l       = prv;
	        }
	
	        return l;
	}
	
	private int sendStr(char *arg)
	{
		if (send(sock, arg, strlen(arg), 0) < 0)
			return 0;

		return 1;
	}

	public int readStr()
	{
		unsigned int	res;
	
		if ((res = recv(sock, buf, BUFLEN, 0)) < 0)
		{
			system.out.writeln("HagelslagInterface::readStr()\n");
			return 0;
		}
		if (res < BUFLEN - 1)
			buf[res + 1]	= 0;
		else
			buf[BUFLEN - 1]	= 0;
	
		return res;
	}
       	
	public String getHagelslagVersion()
	{
		char	*finder;
		
		if (!sendStr("version\n"))
		{
			*ver	= 0;
			return;
		}
        	
		if (!readStr())
		{
			*ver	= 0;
			return;
		}      	
		
		if ((finder = strstr(buf, "\r\n")))
			*finder		= 0;
		else
		{
			*ver	= 0;
			return;
		}
       	
		strcpy(ver, buf);
	}              	

	public String getApiVersion()
	{
		return API_VERSION;
	}       	
}
