/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

import List;

class OptionList extends List
{

	private int	maxTTL;
	private int	defaultTTL;
	private int	routingTableSize;
	private int	maxConnections;
	private int	maxResults;
	private int	maxHops;
	private int	maxPushRequests;
	private int	maxUploads;
	private int	maxDownloads;
	private int	maxHosts;
	private int	port;
	private int	speed;
	private int	monitorLength;
	private boolean	autoPush;
	private boolean	autoClearComplete;
	private int	autoConnections;
	private String	downloadDir;
	private int	daemonPort;
		
	public OptionList(int mttl, int dttl, int rts, int mcon, int mres,
			int mhop, int mpr, int mu, int md, int mh, int p,
			int sp, int ml, boolean ap, boolean acc, int ac, String dd,
			int dp)
	{
		super(List.LIST_TYPE_OPTIONS);
		maxTTL			= mttl;
	      	defaultTTL              = dttl;
	        routingTableSize        = rts;
		maxConnections          = mcon;
		maxResults              = mres;
		maxHops			= mhop;
		maxPushRequests         = mpr;
	        maxUploads		= mu;
	        maxDownloads            = md;
	        maxHosts                = mh;
	        port                    = p;
	        speed                   = sp;
		monitorLength           = ml;
	        autoPush                = ap;
		autoClearComplete       = acc;
	        autoConnections         = ac;
		daemonPort              = dp;
		downloadDir		= new String(dd);
	}
			
	OptionList(int mttl, int dttl, int rts, int mcon, int mres,
		int mhop, int mpr, int mu, int md, int mh, int p,
		int sp, int ml, boolean ap, boolean acc, int ac, String dd,
		int dp, List newNext)
	{
		super(List.LIST_TYPE_OPTIONS, newNext);
		maxTTL			= mttl;
       		defaultTTL              = dttl;
        	routingTableSize        = rts;
	        maxConnections          = mcon;
	        maxResults              = mres;
	        maxHops			= mhop;
	        maxPushRequests         = mpr;
	        maxUploads		= mu;
	        maxDownloads            = md;
	        maxHosts                = mh;
	        port                    = p;
	        speed                   = sp;
		monitorLength           = ml;
	        autoPush                = ap;
		autoClearComplete       = acc;
	        autoConnections         = ac;
		daemonPort              = dp;
		downloadDir		= new String(dd);
	}
			
		public int	getMaxTTL()
		{
			return maxTTL;
		}
		
		public int	getDefaultTTL()
		{
			return defaultTTL;
		}
		
		public int	getRoutingTableSize()
		{
			return routingTableSize;
		}
		
		public int	getMaxConnections()
		{
			return maxConnections;
		}
		
		public int	getMaxResults()
		{
			return maxResults;
		}
		
		public int	getMaxHops()
		{
			return maxHops;
		}
		
		public int	getMaxPushRequests()
		{
			return maxPushRequests;
		}
		
		public int	getMaxUploads()
		{
			return maxUploads;
		}
		
		public int	getMaxDownloads()
		{
			return maxDownloads;
		}
		
		public int	getMaxHosts()
		{
			return maxHosts;
		}
		
		public int	getPort()
		{
			return port;
		}
		
		public int	getSpeed()
		{
			return speed;
		}
		
		public int	getMonitorLength()
		{
			return monitorLength;
		}
		
		public boolean	getAutoPush()
		{
			return autoPush;
		}
		
		public boolean	getAutoClearComplete()
		{
			return autoClearComplete;
		}
		
		public int	getAutoConnections()
		{
			return autoConnections;
		}
		
		public String	getDownloadDir()
		{
			return downloadDir;
		}
		
		public int	getDaemonPort()
		{
			return daemonPort;
		}
}
