/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

import List;

class StatList extends List
{
	private int	hostsOnNet;
	private	int	filesOnNet;
	private	int	sizeOnNet;
	private	int	filesShared;
	private	int	sizeShared;
	
	public	StatList(int hon, int fon, int son, int fs, int ss)
	{
		super(List.LIST_TYPE_STATS);
       		hostsOnNet      = hon;
	        filesOnNet      = fon;
		sizeOnNet       = son;
	        filesShared     = fs;
	        sizeShared      = ss;
	}
 
	public	StatList(int hon, int fon, int son, int fs, int ss,
				List newNext)
	{
		super(List.LIST_TYPE_STATS, newNext);
       		hostsOnNet      = hon;
	        filesOnNet      = fon;
		sizeOnNet       = son;
	        filesShared     = fs;
	        sizeShared      = ss;
	}
 
	public	int	getHostsOnNet()
	{
		return hostsOnNet;
	}
		
	public	int	getFilesOnNet()
	{
		return filesOnNet;
	}
		
	public	int	getSizeOnNet()
	{
		return sizeOnNet;
	}
		
	public	int	getFilesShared()
	{
		return filesShared;
	}
		
	public	int	getSizeShared()
	{
		return sizeShared;
	}
}
