/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

import List;

class UploadList extends List
{
	private int	id;
	private String	host;
	private String	fileName;
	private String	state;
	private int	fileIndex;
	private	int	doneBytes;
	private	int	totalBytes;
	private	int	kbps;
		
	public UploadList(int newID, String h, String fn, String st, int fid,
				int db, int tb, int ks)
	{
		super(List.LIST_TYPE_UPLOADS);
		id		= newID;
		host		= new String(h);
		fileName	= new String(fn);
		state		= new String(st);
		fileIndex	= fid;
		doneBytes	= db;
		totalBytes	= tb;
		kbps		= ks;
	}
		
	public UploadList(int newID, String h, String fn, String st, int fid,
			int db, int tb, int ks, List newNext)
	{
		super(List.LIST_TYPE_UPLOADS, newNext);
		id		= newID;
		host		= new String(h);
		fileName	= new String(fn);
		state		= new String(st);
		fileIndex	= fid;
		doneBytes	= db;
		totalBytes	= tb;
		kbps		= ks;
	}
	
	public	int	getID()
	{
		return id;
	}
		
	public	String getHost()
	{
		return host;
	}
		
	public	String	getFileName()
	{
		return fileName;
	}
		
	public	String	getState()
	{
		return state;
	}
	
	public	int	getFileIndex()
	{
		return fileIndex;
	}

	public	int	getDoneBytes()
	{
		return doneBytes;
	}
		
	public	int	getTotalBytes()
	{
		return totalBytes;
	}
		
	public	int	getKbps()
	{
		return kbps;
	}
}
