/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>
#include <stdio.h>
#include <time.h>
#include <List.h>
#include <ConnectionList.h>
#include <DownloadList.h>
#include <ErrorList.h>
#include <HostList.h>
#include <OptionList.h>
#include <QueryList.h>
#include <ResultList.h>
#include <ShareList.h>
#include <StatList.h>
#include <UploadList.h>
#include <ListMaker.h>
#include <HagelslagInterface.h>
#include "UserTranslator.h"
#include "ListTranslator.h"
#include "TestGui.h"


TestGui::TestGui()
{
	inbuf[0]	= 0;
}

int main(int argc, char **argv)
{
	TestGui		t;

	return t.mainloop(argc, argv);
}

int TestGui::mainloop(int argc, char **argv)
{
	List	*l;

	/*
	 * In stead of a fixed port I recommend using a random port
	 */
	if (!iface.startHagelslag("../../bin/hagelslagd", 6667))
		if (!iface.startHagelslag("./hagelslagd", 6667))
			if (!iface.startHagelslag("./bin/hagelslagd",
								6667))
				if (!iface.startHagelslag(0, 6667))
				{
					fprintf(stderr, "Start failed\r\n");
					return 0;
				}

	if (!iface.connectHagelslag())
	{
		fprintf(stderr, "Connect failed\r\n");
		return 0;
	}
	
	printf(PROMPT);
	fgets(inbuf, INBUFLEN, stdin);
	inbuf[ INBUFLEN - 1 ]	= 0;
	l			= 0;

	while (1)
	{
		char	arg[1024];

		switch (ut.translate(inbuf))
		{
			case	COMMAND_LIST	:
						l	= 
						iface.list(ut.getListType(),
							ut.getListOffset());
					break;
			case	COMMAND_SET	:
						ut.getSetArg(arg);
						l	=	(List *)
						iface.set(ut.getSetParam(), 
							ut.getSetVal(), arg);
					break;
			case	COMMAND_HOST	:
						ut.getHostArg(arg);
						l	= 	(List *)
						iface.host(ut.getHostAction(),
							ut.getHostWho(),
							arg);
					break;
			case	COMMAND_DOWNLOAD	:
						l	=	(List *)
						iface.download(ut.getDownloadMethod(),
							ut.getDownloadWhich());
					break;
			case	COMMAND_SHARE	:
						ut.getShareArg(arg);
						l	=	(List *)
						iface.share(ut.getShareMethod(),
							arg);
					break;
			case	COMMAND_SAVE	:
						l	=	(List *)
						iface.save(ut.getSaveWhat());
					break;
			case	COMMAND_SEARCH	:
						ut.getSearchPattern(arg);
						l	=	(List *)
						iface.search(SEARCH_FIND,
							ut.getSearchSpeed(), arg);
					break;
			case	COMMAND_QUIT	:
						iface.stopHagelslag();
						return 0;
			case	COMMAND_HOLDON	:
						printf("disconnect .... ");
						if (!iface.disconnectHagelslag())
						{
							printf("FAILED!!!\r\n");
							return 0;
						}
						printf("OK\r\nconnect .... ");
						if (!iface.connectHagelslag())
						{
							printf("FAILED!!!\r\n");
							return 0;
						}
						printf("OK\r\n");
						break;
			case	COMMAND_VERSION	:
						iface.getHagelslagVersion(arg);
						printf("HAGELSLAG-VERSION : %s\n", arg);
						iface.getApiVersion(arg);
						printf("API-VERSION : %s\n", arg);
						break;
			case	COMMAND_KILL	:
					l	=	(List *)
						iface.kill(ut.getKillWhat(),
							ut.getKillWho());
					break;
			default:
				break;
		}

		if (lt.listToStr(l, outbuf))
			printf(outbuf);

		printf(PROMPT);

		while (l)
		{
			List	*prv;

			prv	= l;
			l	= l->getNext();
			delete prv;
		}
		fgets(inbuf, INBUFLEN, stdin);
		inbuf[ INBUFLEN - 1 ]	= 0;
	}

	return 0;
}


