/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <List.h>
#include <ConnectionList.h>
#include <DownloadList.h>
#include <ErrorList.h>
#include <HostList.h>
#include <OptionList.h>
#include <QueryList.h>
#include <ResultList.h>
#include <ShareList.h>
#include <StatList.h>
#include <UploadList.h>
#include <ListMaker.h>
#include <HagelslagInterface.h>
#include "UserTranslator.h"

UserTranslator::UserTranslator()
{
	command		= COMMAND_INVALID;
	listType	= -1;
}

int UserTranslator::translate(char *buf)
{
	if (!strncmp(buf, "list", strlen("list")))
	{
		command		= COMMAND_LIST;
		buf		+= strlen("list");
		while(*buf == ' ')
			buf++;

		if (!strncmp(buf, "results", strlen("results")))
		{
			listType	= LIST_RESULTS;
			buf		+= strlen("results");
			while(*buf == ' ')
				buf++;
			listOffset	= atoi(buf);
		}
		else if (!strncmp(buf, "hosts", strlen("hosts")))
		{
			listType	= LIST_HOSTS;
			buf		+= strlen("hosts");
			while(*buf == ' ')
				buf++;
			listOffset	= atoi(buf);
		}
		else if (!strncmp(buf, "downloads", strlen("downloads")))
		{
			listType	= LIST_DOWNLOADS;
		}
		else if (!strncmp(buf, "uploads", strlen("uploads")))
		{
			listType	= LIST_UPLOADS;
		}
		else if (!strncmp(buf, "connections",
						strlen("connections")))
		{
			listType	= LIST_CONNECTIONS;
			buf		+= strlen("connections");
			while(*buf == ' ')
				buf++;
			listOffset	= atoi(buf);
		}
		else if (!strncmp(buf, "shares", strlen("shares")))
		{
			listType	= LIST_SHARES;
		}
		else if (!strncmp(buf, "options", strlen("options")))
		{
			listType	= LIST_OPTIONS;
		}
		else if (!strncmp(buf, "stats", strlen("stats")))
		{
			listType	= LIST_STATS;
		}
		else if (!strncmp(buf, "queries", strlen("queries")))
		{
			listType	= LIST_QUERIES;
		}
		else
			listType	= -1;
	}
	else if (!strncmp(buf, "set", strlen("set")))
	{
		command		= COMMAND_SET;
		buf		+= strlen("set");
		while(*buf == ' ')
			buf++;

		if (!strncmp(buf, "MAX_TTL", strlen("MAX_TTL")))
		{
			setParam	= SET_MAX_TTL;
			buf		+= strlen("MAX_TTL");
		}
		else if (!strncmp(buf, "DEFAULT_TTL", strlen("DEFAULT_TTL")))
		{
			setParam	= SET_DEFAULT_TTL;
			buf		+= strlen("DEFAULT_TTL");
		}
		else if (!strncmp(buf, "MAX_CONNECTIONS", 
					strlen("MAX_CONNECTIONS")))
		{
			setParam	= SET_MAX_CONNECTIONS;
			buf		+= strlen("MAX_CONNECTIONS");
		}
		else if (!strncmp(buf, "ROUTING_TABLE_SIZE", 
					strlen("ROUTING_TABLE_SIZE")))
		{
			setParam	= SET_ROUTING_TABLE_SIZE;
			buf		+= strlen("ROUTING_TABLE_SIZE");
		}
		else if (!strncmp(buf, "MAX_HOPS", strlen("MAX_HOPS")))
		{
			setParam	= SET_MAX_HOPS;
			buf		+= strlen("MAX_HOPS");
		}
		else if (!strncmp(buf, "MAX_UPLOADS", strlen("MAX_UPLOADS")))
		{
			setParam	= SET_MAX_UPLOADS;
			buf		+= strlen("MAX_UPLOADS");
		}
		else if (!strncmp(buf, "MAX_DOWNLOADS", strlen("MAX_DOWNLOADS")))
		{
			setParam	= SET_MAX_DOWNLOADS;
			buf		+= strlen("MAX_DOWNLOADS");
		}
		else if (!strncmp(buf, "MAX_RESULTS", strlen("MAX_RESULTS")))
		{
			setParam	= SET_MAX_RESULTS;
			buf		+= strlen("MAX_RESULTS");
		}
		else if (!strncmp(buf, "PORT", strlen("PORT")))
		{
			setParam	= SET_PORT;
			buf		+= strlen("PORT");
		}
		else if (!strncmp(buf, "SPEED", strlen("SPEED")))
		{
			setParam	= SET_SPEED;
			buf		+= strlen("SPEED");
		}
		else if (!strncmp(buf, "DOWNLOAD_DIR", strlen("DOWNLOAD_DIR")))
		{
			setParam	= SET_DOWNLOAD_DIR;
			buf		+= strlen("DOWNLOAD_DIR");
		}
		else if (!strncmp(buf, "AUTO_PUSH", strlen("AUTO_PUSH")))
		{
			setParam	= SET_AUTO_PUSH;
			buf		+= strlen("AUTO_PUSH");
		}
		else if (!strncmp(buf, "AUTO_CLEAR_COMPLETE", 
						strlen("AUTO_CLEAR_COMPLETE")))
		{
			setParam	= SET_AUTO_CLEAR_COMPLETE;
			buf		+= strlen("AUTO_CLEAR_COMPLETE");
		}
		else if (!strncmp(buf, "AUTO_CONNECTIONS",	
						strlen("AUTO_CONNECTIONS")))
		{
			setParam	= SET_AUTO_CONNECTIONS;
			buf		+= strlen("AUTO_CONNECTIONS");
		}
		else if (!strncmp(buf, "MAX_MONITOR_LENGTH",
						strlen("MAX_MONITOR_LENGTH")))
		{
			setParam	= SET_MAX_MONITOR_LENGTH;
			buf		+= strlen("MAX_MONITOR_LENGTH");
		}
		else
			setParam	= -1;

		while(*buf == ' ')
			buf++;

		setVal	= atoi(buf);
		strncpy(setArg, buf, 510);
		setArg[511]	= 0;
	}
	else if (!strncmp(buf, "host", strlen("host")))
	{
		command		= COMMAND_HOST;
		buf		+= strlen("host");
		while(*buf == ' ')
			buf++;

		if (!strncmp(buf, "add", strlen("add")))
		{
			hostAction	= HOST_ADD;
			buf		+= strlen("add");
		}
		else if (!strncmp(buf, "del", strlen("del")))
		{
			hostAction	= HOST_DEL;
			buf		+= strlen("del");
		}
		else if (!strncmp(buf, "connect", strlen("connect")))
		{
			hostAction	= HOST_CONNECT;
			buf		+= strlen("connect");
		}
		else
			hostAction	= -1;

		while(*buf == ' ')
			buf++;

		hostWho	= atoi(buf);
		strncpy(hostArg, buf, 98);
		hostArg[99]	= 0;
	}
	else if (!strncmp(buf, "download", strlen("download")))
	{
		command		= COMMAND_DOWNLOAD;
		buf		+= strlen("download");
		while(*buf == ' ')
			buf++;

		if (!strncmp(buf, "start", strlen("start")))
		{
			downloadMethod	= DOWNLOAD_HOW_START;
			buf		+= strlen("");
		}
		else if (!strncmp(buf, "continue", strlen("continue")))
		{
			downloadMethod	= DOWNLOAD_HOW_CONTINUE;
			buf		+= strlen("");
		}
		else if (!strncmp(buf, "push", strlen("push")))
		{
			downloadMethod	= DOWNLOAD_HOW_PUSH;
			buf		+= strlen("");
		}

		while(*buf == ' ')
			buf++;

		downloadWhich	= atoi(buf);
	}
	else if (!strncmp(buf, "kill", strlen("kill")))
	{
		command		= COMMAND_KILL;
		buf		+= strlen("kill");
		while(*buf == ' ')
			buf++;

		if (!strncmp(buf, "download", strlen("download")))
		{
			killWhat	= KILL_DOWNLOAD;
			buf		+= strlen("download");
		}
		else if (!strncmp(buf, "upload", strlen("upload")))
		{
			killWhat	= KILL_UPLOAD;
			buf		+= strlen("upload");
		}
		else if (!strncmp(buf, "connection", strlen("connection")))
		{
			killWhat	= KILL_CONNECTION;
			buf		+= strlen("connection");
		}
		else
			killWhat	= -1;

		while(*buf == ' ')
			buf++;

		killWho	= atoi(buf);
	}
	else if (!strncmp(buf, "share", strlen("share")))
	{
		command		= COMMAND_SHARE;
		buf		+= strlen("share");
		while(*buf == ' ')
			buf++;
		strncpy(shareArg, buf, 254);
		shareArg[255]	= 0;
	}
	else if (!strncmp(buf, "save", strlen("save")))
	{
		command		= COMMAND_SAVE;
		buf		+= strlen("save");
		while(*buf == ' ')
			buf++;
		if (!strncmp(buf, "options", strlen("options")))
			saveWhat	= SAVE_OPTIONS;
		else if (!strncmp(buf, "hosts", strlen("hosts")))
			saveWhat	= SAVE_HOSTS;
		else if (!strncmp(buf, "shares", strlen("shares")))
			saveWhat	= SAVE_SHARES;
		else
			saveWhat	= -1;

	}
	else if (!strncmp(buf, "search", strlen("search")))
	{
		command		= COMMAND_SEARCH;
		buf		+= strlen("search");
		while(*buf == ' ')
			buf++;

		searchSpeed	= atoi(buf);
		while ( (*buf != ' ') && *buf)
			buf++;
		while(*buf == ' ')
			buf++;

		strncpy(searchPattern, buf, 254);
		searchPattern[255]	= 0;
	}
	else if (!strncmp(buf, "quit", strlen("quit")))
	{
		command		= COMMAND_QUIT;
	}
	else if (!strncmp(buf, "holdon", strlen("holdon")))
	{
		command		= COMMAND_HOLDON;
	}
	else if (!strncmp(buf, "version", strlen("version")))
	{
		command		= COMMAND_VERSION;
	}
	else
		command		= COMMAND_INVALID;

	return command;
}

int UserTranslator::getListType()
{
	return listType;
}

int UserTranslator::getListOffset()
{
	return listOffset;
}

int UserTranslator::getSetParam()
{
	return setParam;
}

int UserTranslator::getSetVal()
{
	return setVal;
}

int UserTranslator::getHostAction()
{
	return hostAction;
}

int UserTranslator::getHostWho()
{
	return hostWho;
}

int UserTranslator::getDownloadMethod()
{
	return downloadMethod;
}

int UserTranslator::getDownloadWhich()
{
	return downloadWhich;
}

int UserTranslator::getShareMethod()
{
	return shareMethod;
}

int UserTranslator::getSaveWhat()
{
	return saveWhat;
}

int UserTranslator::getSearchSpeed()
{
	return searchSpeed;
}

int UserTranslator::getKillWhat()
{
	return killWhat;
}

int UserTranslator::getKillWho()
{
	return killWho;
}

/*
int UserTranslator::get()
{
	return ;
}

int UserTranslator::get()
{
	return ;
}

int UserTranslator::get()
{
	return ;
}

int UserTranslator::get()
{
	return ;
}
*/

int UserTranslator::getSetArg(char *buf)
{
	strcpy(buf, setArg);
	return 1;
}

int UserTranslator::getHostArg(char *buf)
{
	strcpy(buf, hostArg);
	return 1;
}

int UserTranslator::getShareArg(char *buf)
{
	strcpy(buf, shareArg);
	return 1;
}

int UserTranslator::getSearchPattern(char *buf)
{
	strcpy(buf, searchPattern);
	return 1;
}

/*
int UserTranslator::get(char *buf)
{
	strcpy(buf, );
	return 1;
}

int UserTranslator::get(char *buf)
{
	strcpy(buf, );
	return 1;
}

int UserTranslator::get(char *buf)
{
	strcpy(buf, );
	return 1;
}

int UserTranslator::get(char *buf)
{
	strcpy(buf, );
	return 1;
}

int UserTranslator::get(char *buf)
{
	strcpy(buf, );
	return 1;
}

int UserTranslator::get(char *buf)
{
	strcpy(buf, );
	return 1;
}

int UserTranslator::get(char *buf)
{
	strcpy(buf, );
	return 1;
}

*/
